#!/bin/bash
. /usr/share/eole/FonctionsEoleNg
. /usr/bin/ParseDico

LDIF=/var/lib/ldap.ldif

echo
EchoVert "Sauvegarde de l'annuaire dans $LDIF"
/etc/init.d/slapd stop >/dev/null
slapcat | grep -Ev '^(entryUUID|entryCSN|structuralObjectClass)' > $LDIF
echo
EchoVert "Réindexation de l'annuaire"
echo
touch /etc/sysconfig/eole/replication
rm -f /var/lib/ldap/*.*
/usr/share/creole/creolecat.py -o /etc/ldap/slapd.conf -i /etc/eole/config.eol /etc/eole/template/slapd.conf
slapadd -l /var/lib/ldap.ldif
chown openldap:openldap /var/lib/ldap/*.*
/usr/share/eole/backend/ldap_pwd.py `/usr/bin/pwgen -1` >/dev/null
grep -q "cn=replicator,o=gouv,c=fr" $LDIF
if [ $? -eq 0 ];then
	EchoOrange "** Le compte de réplication existe déjà **"
	if [ ! -f /root/.replicator ];then
		EchoRouge "Erreur : impossible de récupérer le mot de passe du compte"
		echo
		exit 1
	fi
	EchoVert "=> Utilisation du compte existant"
	echo
	replicator_pwd=`cat /root/.replicator`	
else
	EchoVert "Création du compte de réplication"
	echo
	replicator_pwd=`/usr/bin/pwgen -1`
	# FIXME (hum)
	echo $replicator_pwd > /root/.replicator
	replicator_crypt=`/usr/share/eole/backend/gen_SSHA.pl -p $replicator_pwd`
	# ldif pour le compte replicator
	cat > /tmp/replicator.ldif <<EOF
dn: cn=replicator,o=gouv,c=fr
objectClass: person
sn: Compte de replication
cn: replicator
userPassword: $replicator_crypt
EOF
	/usr/share/eole/backend/lance-ldif.py -f /tmp/replicator.ldif
	rm -f /tmp/replicator.ldif
fi
echo
EchoVert "Génération de la configuration client"
echo
ReadDefault "Adresse utilisée pour accéder au Scribe depuis le client" "$adresse_ip_eth0"
adresse_scribe=$reponse
EchoVert "Connexion client..."
ReadDefault "Adresse du client" "$passerelle_smtp_aca"
adresse_client=$reponse
cat > /root/replication.conf <<EOF
syncrepl rid=123
        provider=ldap://$adresse_client:389
        type=refreshOnly
        interval=00:01:00:00
        searchbase="o=gouv,c=fr"
        filter="(objectClass=inetOrgPerson)"
        scope=sub
        schemachecking=off
        bindmethod=simple
        binddn="cn=replicator,o=gouv,c=fr"
        credentials=$replicator_pwd
EOF
echo "fin"

